<!DOCTYPE composition PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<!-- IGAC proyecto SNC

@author: javier.aponte 									
@description Pantalla de la actividad corespondiente a trámites devueltos del proceso de asignación	
@cu CU-CO-A-03
@version 2.0
@modified lorena.salamanca Se actualiza para la migracion de PrimeFaces 3.2 

@modified leidy.gonzalez Se agrega columna de derecho de peticio o tutela
-->

<ui:composition xmlns="http://www.w3.org/1999/xhtml"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:p="http://primefaces.org/ui"
                xmlns:tramite="http://java.sun.com/jsf/composite/tramite"
                xmlns:misc="http://java.sun.com/jsf/composite/misc"
                xmlns:predio="http://java.sun.com/jsf/composite/predio"
                template="/templates/generalCU.xhtml">

    <ui:define name="content">
        <p:messages id="msgsTramiteDevuelto" showDetail="false"
                    globalOnly="false" />
        <p:ajaxStatus onstart="statusDialog.show();"
                      onsuccess="statusDialog.hide();" />

        <p:spacer height="30" width="0" />

        <p:fieldset toggleable="true" toggleSpeed="500">

            <legend>
                <h:outputLabel value="Trámite devuelto" styleClass="legendTitle" />
            </legend>

            <tramite:tramiteResumen id="tabsgridI" muestraTipoSolicitudParam="true"	muestraClasificacionParam="true" 
                                    muestraFechaRadicacionParam="true" muestraFechaSolicitudParam="true" 
                                    muestraDerechoPeticionParam="true" tramiteParam="#{tramiteDevuelto.tramite}"/>

            <h:form id="tramiteDevueltoForm">

                <h:panelGrid columns="1" id="tramiteDevueltoPanel" width="100%">
                    <h:panelGrid columns="4" width="50%">

                        <h:outputLabel value="Ejecutor Asignado:" for="ejecutorAsignado"
                                       styleClass="outputLabelStyle" />
                        <h:outputText id="ejecutorAsignado" style="width:150px"
                                      styleClass="outputTextStyle"
                                      value="#{tramiteDevuelto.tramite.nombreFuncionarioEjecutor}" />

                        <h:outputLabel value="Documentos Asociados: "
                                       for="documentosAsociados" styleClass="outputLabelStyle" />

                        <p:commandLink oncomplete="solicitarDocumentacionWV.show()"
                                       update=":solicitarDocumentacionForm">
                            <f:setPropertyActionListener value="false"
                                                         target="#{tramiteDevuelto.verSolicitudDocsBool}"/>
                            <h:outputText id="documentosAsociados" style="width:150px"
                                          styleClass="commandLinkStyle"
                                          value="#{tramiteDevuelto.countDocumentosTramiteSeleccionado}" />
                        </p:commandLink>

                        <h:outputLabel value="Motivo Devolución:" for="motivoDevolucion"
                                       styleClass="outputLabelStyle" />
                        <h:outputText id="motivoDevolucion" style="width:150px"
                                      styleClass="outputTextStyle"
                                      value="#{tramiteDevuelto.estadoTramite.motivo}" />

                    </h:panelGrid>

                    <h:panelGrid columns="2">

                        <h:outputLabel value="Observaciones:" for="observaciones"
                                       styleClass="outputLabelStyle" />
                        <h:inputTextarea id="observaciones" disabled="true" rows="3"
                                         onkeydown="controlarNroChars(this, 2000, true);"
                                         onkeyup="controlarNroChars(this, 2000, true);"
                                         cols="140" value="#{tramiteDevuelto.estadoTramite.observaciones}" />
                    </h:panelGrid>

                    <h:panelGrid columns="1" id="panelAceptaDevolucion"
                                 rendered="#{tramiteDevuelto.mostrarAceptaDevolucion}">
                        <p:fieldset toggleable="true" toggleSpeed="500">

                            <legend>
                                <h:outputLabel value="Acepta devolución"
                                               styleClass="legendTitle" />
                            </legend>

                            <p:selectManyCheckbox value="#{tramiteDevuelto.motivosDevolucionAceptados}"
                                                  layout="pageDirection">
                                <p:ajax update="panelBotonesMotivosAceptados, tramiteDevueltoForm" 
                                        listener="#{tramiteDevuelto.activarBotonesMotivosAceptados}"/>  
                                <f:selectItems value="#{tramiteDevuelto.aceptaMotivoDevolucion}" />  
                            </p:selectManyCheckbox>
                        </p:fieldset>
                    </h:panelGrid>

                    <h:panelGrid columns="2" rendered = "#{tramiteDevuelto.activarSeleccionSolucionadosOtrosMotivos}">    
                        <p:selectBooleanCheckbox value="#{tramiteDevuelto.solucionadosOtrosMotivos}">
                            <p:ajax update="panelBotonesMotivosAceptados" 
                                    listener="#{tramiteDevuelto.activarBotonesMotivosAceptados}"/> 
                        </p:selectBooleanCheckbox>
                        <h:outputLabel value="Solucionados otros motivos"/>
                    </h:panelGrid>

                    <p:spacer height="50" width="0" />

                    <h:panelGrid columns="6" id="panelBotonesMotivosAceptados">

                        <p:commandButton value="Solicitar documentos"
                                         icon="ui-icon-seek-next"
                                         title="Mover el trámite (sin comisión o comisión cancelada) a la actividad de solicitud de documentos"
                                         ajax="false" action="#{tramiteDevuelto.solicitarDocumentos}"
                                         rendered="#{tramiteDevuelto.activarBotonSolicitarDocumentos and (!tramiteDevuelto.tramite.tramiteComisionado or 
                                                     (tramiteDevuelto.tramite.tramiteComisionado and tramiteDevuelto.tramite.comisionTramite.comision.comisionCancelada))}" />

                        <p:commandButton value="Solicitar documentos"
                                         icon="ui-icon-seek-next"
                                         title="Mover el trámite (con comisión no cancelada) a la actividad de solicitud de documentos"
                                         oncomplete="solicitarDocumentosConfirmWV.show();"
                                         rendered="#{tramiteDevuelto.activarBotonSolicitarDocumentos and  
                                                     (tramiteDevuelto.tramite.tramiteComisionado and !tramiteDevuelto.tramite.comisionTramite.comision.comisionCancelada)}" />



                        <p:commandButton value="Reclasificar trámite" icon="ui-icon-copy"
                                         title="Reclasificar trámite sin comisión o con comisión cancelada"
                                         update=":tramiteDevueltoForm:tramiteDevueltoPanel, :msgsTramiteDevuelto, :tabsgridI:tramiteForm"
                                         action="#{tramiteDevuelto.reclasificarTramite}"
                                         rendered="#{tramiteDevuelto.activarBotonReclasificarTramite and (!tramiteDevuelto.tramite.tramiteComisionado or 
                                                     (tramiteDevuelto.tramite.tramiteComisionado and tramiteDevuelto.tramite.comisionTramite.comision.comisionCancelada))}" />

                        <p:commandButton value="Reclasificar trámite"
                                         title="Reclasificar trámite comisionado con comisión no cancelada"
                                         oncomplete="reclasificarTramiteComisionadoWV.show()"
                                         icon="ui-icon-copy"
                                         rendered="#{tramiteDevuelto.activarBotonReclasificarTramite and tramiteDevuelto.tramite.tramiteComisionado and 
                                                     !tramiteDevuelto.tramite.comisionTramite.comision.comisionCancelada}" />


                        <p:commandButton value="Desasignar ejecutor" icon="ui-icon-cancel"
                                         oncomplete="desasignarEjecutorTramiteComisionadoWV.show()"
                                         title="Desasignar el ejecutor con comisión no cancelada al ejecutor "
                                         rendered="#{tramiteDevuelto.activarBotonDesasignarTramite and 
                                                     (tramiteDevuelto.tramite.tramiteComisionado and !tramiteDevuelto.tramite.comisionTramite.comision.comisionCancelada)}" />

                        <p:commandButton value="Desasignar ejecutor" icon="ui-icon-cancel"
                                         title="Desasignar el ejecutor. Trámite sin comisión o con comisión cancelada"
                                         action="#{tramiteDevuelto.desasignarEjecutorDeTramite}"
                                         update=":tramiteDevueltoForm:tramiteDevueltoPanel, ejecutorAsignado, :msgsTramiteDevuelto"
                                         rendered="#{tramiteDevuelto.activarBotonDesasignarTramite and 
                                                     (!tramiteDevuelto.tramite.tramiteComisionado or (tramiteDevuelto.tramite.tramiteComisionado and tramiteDevuelto.tramite.comisionTramite.comision.comisionCancelada))}" />


                        <p:commandButton value="Devolver a ejecutor"
                                         icon="ui-icon-person"
                                         title="Devuelve el trámite (sin comisión o con comisión no cancelada) al ejecutor "
                                         ajax="false" 
                                         action="#{tramiteDevuelto.devolverAEjecutor}" 
                                         rendered="#{tramiteDevuelto.activarBotonDevolverAEjecutor and 
                                                     (!tramiteDevuelto.tramite.tramiteComisionado or (tramiteDevuelto.tramite.tramiteComisionado and !tramiteDevuelto.tramite.comisionTramite.comision.comisionCancelada))}"/>

                        <p:commandButton value="Devolver a ejecutor"
                                         icon="ui-icon-person"
                                         title="Devuelve el trámite al ejecutor. Tiene comisión cancelada"
                                         oncomplete="confirmDevolverAEjecutorWV.show();"
                                         rendered="#{tramiteDevuelto.activarBotonDevolverAEjecutor and 
                                                     (tramiteDevuelto.tramite.tramiteComisionado and tramiteDevuelto.tramite.comisionTramite.comision.comisionCancelada)}">

                            <f:setPropertyActionListener value="true"
                                                         target="#{tramiteDevuelto.tramiteConComisionCancelada}" />
                        </p:commandButton>



                        <p:commandButton value="Aceptar" icon="ui-icon-seek-next"
                                         action="#{tramiteDevuelto.aceptarYAvanzarProceso}" ajax="false"
                                         rendered="#{tramiteDevuelto.activarBotonAceptar}"
                                         title="Mueve el trámite de vuelta" />

                    </h:panelGrid>
                </h:panelGrid>

                <p:spacer height="0" width="30" />

                <p:separator style="width:925px;height:3px" />
                <p:spacer height="7" width="0" />
                <p:outputPanel layout="block" style="text-align:right">
                    <p:commandButton value="Cerrar" icon="ui-icon-circle-close"
                                     action="#{tramiteDevuelto.cerrarPaginaPrincipal}" ajax="false"
                                     immediate="true" />
                    <p:spacer height="0" width="30" />
                </p:outputPanel>
                <p:spacer height="20" width="0" />

                <p:confirmDialog appendToBody="true"
                                 message="Este trámite tiene una comisión asignada. ¿Está seguro que desea reclasificar?"
                                 width="400" 
                                 header="Confirmación" severity="alert"
                                 widgetVar="reclasificarTramiteComisionadoWV">

                    <p:commandButton value="Sí"
                                     update=":viewReport:vistaMemoForm, tramiteDevueltoForm"
                                     action="#{tramiteDevuelto.reclasificarTramiteConComisionNoCancelada}"
                                     icon="ui-icon-check"
                                     onstart="statusDialog2.show()"
                                     oncomplete="statusDialog2.hide();visorReporteWV.show();reclasificarTramiteComisionadoWV.hide();"/>

                    <p:commandButton value="No" icon="ui-icon-close"
                                     onclick="reclasificarTramiteComisionadoWV.hide();"
                                     type="button" />
                </p:confirmDialog>

                <p:confirmDialog appendToBody="true"
                                 message="Este trámite tiene una comisión asignada, está seguro que desea desasignar el ejecutor?"
                                 width="400" 
                                 header="Confirmación" severity="alert"
                                 widgetVar="desasignarEjecutorTramiteComisionadoWV">

                    <p:commandButton value="Si"
                                     update=":viewReport:vistaMemoForm, tramiteDevueltoForm"
                                     action="#{tramiteDevuelto.desasignarEjecutorDeTramiteConComisionNoCancelada}"
                                     icon="ui-icon-check"
                                     onstart="statusDialog2.show()"
                                     oncomplete="statusDialog2.hide();visorReporteWV.show();desasignarEjecutorTramiteComisionadoWV.hide();"/>

                    <p:commandButton value="No" icon="ui-icon-close"
                                     onclick="desasignarEjecutorTramiteComisionadoWV.hide();" 
                                     type="button" />
                </p:confirmDialog>

                <p:confirmDialog appendToBody="true"
                                 message="Este trámite tiene una comisión asignada y este trámite se retirará. ¿Está usted seguro?"
                                 width="400" 
                                 header="Confirmación" severity="alert"
                                 widgetVar="solicitarDocumentosConfirmWV">

                    <p:commandButton value="Sí"
                                     update=":viewReport:vistaMemoForm, tramiteDevueltoForm"
                                     action="#{tramiteDevuelto.solicitarDocumentosConComisionNoCancelada}"
                                     icon="ui-icon-check"
                                     onstart="statusDialog2.show()"
                                     oncomplete="statusDialog2.hide();visorReporteWV.show();solicitarDocumentosConfirmWV.hide();"/>

                    <p:commandButton value="No" icon="ui-icon-close"
                                     onclick="solicitarDocumentosConfirmWV.hide();"
                                     type="button" />
                </p:confirmDialog>
            </h:form>
        </p:fieldset>

        <p:dialog header="Detalle del trámite" widgetVar="detalleTramiteEjecutarWV" modal="false" appendToBody="true" resizable="true" position="center"
                  height="480" width="960">
            <ui:include src="/conservacion/ejecucion/detalleTramiteEjecucion.xhtml">
                <ui:param name="currentManagedBeanParam"
                          value="#{vistaDetallesTramite}" />
                <ui:param name="currentDetallePredioWV" value="detallePredioWV" />
            </ui:include>
        </p:dialog>

        <predio:detallesPredioCC id="dpCC" thisWVName="detallePredioWV"
                                 mostrarDatosPropietarios="true" mostrarDatosTramites="true"
                                 thisIdPlusColon=":dpCC" mostrarFichaPredial="true" />

        <!-- Dialog usado para habilitar el tab de origen del predio -->
        <predio:detallesPredioCC id="dpCC2" thisWVName="detallePredioWV2"
                                 mostrarDatosPropietarios="true" mostrarDatosTramites="true"
                                 mostrarFichaPredial="true" thisIdPlusColon=":dpCC2" />

        <p:dialog header="Documentos Asociados"
                  widgetVar="solicitarDocumentacionWV" 
                  appendToBody="true" width="920" height="480">
            <ui:include src="solicitarDocumentacion.xhtml"
                        id="modalTramiteASolicitarDocumentos">
                <ui:param name="managedBeanParam" value="#{tramiteDevuelto}" />
                <ui:param name="selectedTramiteParam"
                          value="#{tramiteDevuelto.tramite}" />
            </ui:include>
        </p:dialog>

        <misc:docViewerWithCloseDecisionCC id="docViewer"
                                           confirmUpdate="msgInfoFis" confirmDialogWV="docViewerWV"
                                           ajaxBehavior="true"
                                           selectedDocumentAtt="#{previsualizacionDocumento.rutaArchivoTemporal}"
                                           showDownloadButton="#{previsualizacionDocumento.documentoDwg}"
                                           fileContent="#{previsualizacionDocumento.reporteDTO.streamedContentReporte}"
                                           doctypeAtt="#{vistaDetallesTramite.tipoMimeDocTemporal}"
                                           headerLabel="Previsualización de documento" yesRendered="false"
                                           noLabel="Cerrar" />
        <ui:include src="/util/visorGeografico.xhtml" />

        <misc:visualizadorMemorandosCC
            id="viewReport"
            thisWVName="visorReporteWV"
            urlDocumento="#{tramiteDevuelto.reporteMemorandoRetirarTramiteComision.urlWebReporte}"
            fileContent="#{tramiteDevuelto.reporteMemorandoRetirarTramiteComision.streamedContentReporte}"
            documentoGenerado="#{tramiteDevuelto.reporteMemorandoRetirarTramiteComision ne null}"
            radicarButtonAction="#{tramiteDevuelto.radicarMemorandoRetirarTramiteComision}"
            radicarButtonEnabled="#{!tramiteDevuelto.banderaDocumentoRadicado}"
            componentsToUpdateOnClose=":tramiteDevueltoForm:tramiteDevueltoPanel, 
            :msgsTramiteDevuelto, :tabsgridI:tramiteForm, :tramiteDevueltoForm:ejecutorAsignado"
            cancelButtonEnabled="true"/>

        <p:dialog header="Detalle de la solicitud" dynamic="true"
                  widgetVar="detalleSolicitudWV" modal="true" appendToBody="true"
                  resizable="true" position="center" height="480" width="960">
            <ui:include
                src="/conservacion/ejecucion/detalleSolicitudEjecutar.xhtml">
                <ui:param name="currentManagedBeanParam"
                          value="#{vistaDetallesSolicitud}" />
                <ui:param name="selectedSolicitudParam"
                          value="#{tramiteDevuelto.tramite.solicitud}" />
                <ui:param name="tramiteResumenID"
                          value="#{cc.attrs.tramiteResumenID}" />
            </ui:include>
        </p:dialog>


        <misc:ultimateConfirmDialogCC
            confirmDialogWV="confirmDevolverAEjecutorWV"
            confirmMessage="Al trámite de terreno seleccionado se le ha cancelado la comisión, por lo que debe ser enviado a la actividad: Comisionar trámites de terreno"
            useStringActionOnYes="true"
            stringActionOnYes="#{tramiteDevuelto.devolverAEjecutor}"
            headerLabel="Confirmación de devolución a ejecutor"/>




    </ui:define>
</ui:composition>